<template>
  <div>
    <v-toolbar
      flat
      height="150px"
      color="primary"
    >
      <v-toolbar-title
        align="midle"
        no-gutters
        style="margin-left:-30px;"
      >
        <a
          href="/"
          class="d-flex align-center"
        >
          <v-img
            class="px-0 mx-0 py-0 my-0"
            :src="imageLink + 'logo_mobisdis_mheader.png'"
            alt="sdis"
            width="320px"
            contain
            eager
          />
        </a>
      </v-toolbar-title>
      <v-btn
        rounded
        text
        href="/"
        class="white--text title font-weight-bold"
      >
        {{ $t('home') }}
      </v-btn>
      <v-btn
        rounded
        text
        :href="$t('urlMobisdis')"
        class=" white--text title font-weight-bold"
      >
        {{ $t('mobisdis') }}
      </v-btn>

      <v-spacer />

      <!--<accessibility />-->
      <v-toolbar-items
        v-if="user"
        class="hidden-md-and-down"
      >
        <MMessageBtn
          :unread-message-number="unreadMessageNumber"
          :text-color-class="'font-weight-bold title white--text'"
        />
        <MHeaderCommunities
          :user-id="user.id"
          :text-color-class="'font-weight-bold title white--text'"
        />
        <MHeaderProfile
          :avatar="user.avatars[0]"
          :short-family-name="(user.shortFamilyName) ? user.givenName+' '+user.shortFamilyName : '-'"
          :text-color-class="'font-weight-bold title white--text'"
          :links-color-class="'primary--text'"
        />
      </v-toolbar-items>

      
      <v-toolbar-items
        v-else
        class="hidden-md-and-down"
      >
        <v-btn
          rounded
          text
          class="white--text title font-weight-bold text-none  mr-6"
          :href="$t('buttons.signup.route')"
        >
          {{ $t('buttons.signup.label') }}
        </v-btn>
        <v-btn
          rounded
          text
          class="white--text title font-weight-bold text-none mr-10"
          :href="$t('buttons.logIn.route')"
        >
          {{ $t('buttons.logIn.label') }}
        </v-btn>
      </v-toolbar-items>
      <v-btn
        v-if="user"
        rounded
        dark
        :disabled="!user"
        :href="$t('buttons.shareAnAd.route')"
        class="hidden-md-and-down white--text title font-weight-bold text-none mr-12"
        color="secondary"
      >
        {{ $t('buttons.shareAnAd.label') }}
      </v-btn>
     
      <div @click="snackbar = true">
        <v-btn
          v-if="!user"
          rounded
          dark
          disabled
          class="hidden-md-and-down title font-weight-bold text-none mr-12"
        >
          {{ $t('buttons.shareAnAd.label') }}
        </v-btn>
      </div>
      <MHeaderLanguage
        text-class="white--text font-weight-bold"
        :languages="languages"
        :language="dlocale"
        @languageSelected="updateLanguage"
      />
      <v-snackbar
        v-if="!user"
        v-model="snackbar"
        color="info"
      >
        {{ $t('snackbar.needConnection') }}
        <v-btn
          color="info"
          icon
          elevation="0"
          @click="snackbar = false"
        >
          <v-icon
            color="primary"
          >
            mdi-close
          </v-icon>
        </v-btn>
      </v-snackbar>


      <!--Display menu when user is connected-->
      <v-menu
        v-if="user"
        bottom
        left
        z-index="9"
      >
        <template v-slot:activator="{ on }">
          <v-btn
            icon
            class="hidden-lg-and-up"
            color="white"
            v-on="on"
          >
            <v-icon>mdi-menu</v-icon>
          </v-btn>
        </template>

        <v-list>
          <v-list-item>
            <v-list-item-title>
              <MHeaderLanguage
                text-class="white--text font-weight-bold"
                :languages="languages"
                :language="dlocale"
                @languageSelected="updateLanguage"
              />
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <MHeaderProfile
                :avatar="user.avatars[0]"
                :short-family-name="(user.shortFamilyName) ? user.givenName+' '+user.shortFamilyName : '-'"
              />
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <MHeaderCommunities
                :user-id="user.id"                  
              />
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                text
                rounded
                :disabled="!user"
                :href="$t('buttons.shareAnAd.route')"
              >
                {{ $t('buttons.shareAnAd.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                text
                rounded
                :href="$t('buttons.messages.route')"
              >
                {{ $t('buttons.messages.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>

      <!--Display menu when there is no connected user-->
      <v-menu
        v-else
        bottom
        left
        z-index="9"
      >
        <template v-slot:activator="{ on }">
          <v-btn
            class="hidden-lg-and-up"
            v-on="on"
          >
            <v-icon color="primary">
              mdi-menu
            </v-icon>
          </v-btn>
        </template>

        <v-list>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                text
                rounded
                :href="$t('buttons.messages.route')"
              >
                {{ $t('buttons.messages.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                rounded
                text
                :href="$t('buttons.signup.route')"
              >
                {{ $t('buttons.signup.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                rounded
                text
                :href="$t('buttons.logIn.route')"
              >
                {{ $t('buttons.logIn.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                text
                rounded
                :disabled="!user"
                :href="$t('buttons.shareAnAd.route')"
                color="secondary light-1"
                elevation="0"
              >
                {{ $t('buttons.shareAnAd.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>
    </v-toolbar>
    <GamificationNotifications :user-gamification-notifications="(user && user.gamificationNotifications) ? user.gamificationNotifications : null" />
    <GratuityNotifications :user-gratuity-notifications="(user && user.gratuityNotifications) ? user.gratuityNotifications : null" />
    <!-- legal guardian dialog -->
    <v-dialog
      v-if="user"
      v-model="activeLegalGuardianDialog"
      persistent
      max-width="900"
    >
      <v-card>
        <v-card-title
          class="text-h5 justify-center"
        >
          {{ $t('dialog.parentalConsent.title') }}
        </v-card-title>
        <v-card-text v-html="$t('dialog.parentalConsent.content',{'legalGuardianEmail':user.legalGuardianEmail})" />
        <v-card-actions>
          <v-spacer />
          <v-btn
            color="secondary"
            primary
            rounded
            :href="this.$t('buttons.logOut.route')"
          >
            {{ $t('dialog.parentalConsent.buttonLabel') }}
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import { merge, has } from "lodash";
import {messages_en, messages_fr, messages_eu} from "@translations/components/base/MHeader/";
import {messages_client_en, messages_client_fr, messages_client_eu} from "@clientTranslations/components/base/MHeader/";
import MHeaderProfile from "@components/base/MHeaderProfile.vue";
import MHeaderLanguage from "@components/base/MHeaderLanguage.vue";
import MHeaderCommunities from "@components/base/MHeaderCommunities.vue";
import MMessageBtn from "@components/base/MMessageBtn.vue";
import GamificationNotifications from "@components/utilities/gamification/GamificationNotifications";
import GratuityNotifications from "@components/utilities/gratuity/GratuityNotifications";

let MessagesMergedEn = merge(messages_en, messages_client_en);
let MessagesMergedEu = merge(messages_eu, messages_client_eu);
let MessagesMergedFr = merge(messages_fr, messages_client_fr);

export default {
  i18n: {
    messages: {
      'en': MessagesMergedEn,
      'eu': MessagesMergedEu,
      'fr': MessagesMergedFr
    }
  },
  components: {
    MHeaderProfile,
    MHeaderLanguage,
    MHeaderCommunities,
    MMessageBtn,
    GamificationNotifications,
    GratuityNotifications
  },
  props: {
    user: {
      type: Object,
      default: null,
    },
    locale: {
      type: String,
      default: "fr"
    },
    languages: {
      type: Object,
      default: () => {}
    },
    token: {
      type: String,
      default: ''
    },
    gamificationActive:{
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      imageLink: "/images/header/",
      width: 0,
      snackbar: null,
      defaultLocale: 'fr',
      dlocale: this.locale,
      activeLegalGuardianDialog: false
    };
  },
  computed:{
    unreadMessageNumber(){
      return this.user.unreadCarpoolMessageNumber + this.user.unreadDirectMessageNumber + this.user.unreadSolidaryMessageNumber; 
    }
  },
  mounted() {
    if (has(this.languages, this.locale)) {
      this.dlocale = this.locale;
    } else {
      this.dlocale = this.defaultLocale;
    }
    this.$store.commit('g/setActive',this.gamificationActive);
    this.$store.commit('grt/setActive',this.gratuityActive);
  },
  created() {
    this.$store.commit('a/setToken',this.user?.token ? this.user.token : this.token);
    if(this.user){
      localStorage.setItem('X-LOCALE',this.dlocale);
    }
    if(this.user?.needParentalConsent) {
      this.activeLegalGuardianDialog = true;
    }
    this.$root.$i18n.locale = this.dlocale
  },
  methods:{
    updateLanguage(language) {
      this.$root.$i18n.locale = language
    },
  }
};
</script>
